include 'icodecod.inc'
decode_bmp:
	mov	ebx,I_END+54
decode_bmp1:
	push	dword converted
	push	word[I_END+22]
	push	word[I_END+18]
	pop	dword[IMG_INFO_Sizes]

	mov	ecx,I_END
	add	ecx,[ecx+2]
	mov	[soi],ecx
	movzx	ebp,word[I_END+18]
	lea	ebp,[ebp+ebp*2]     ; ebp = size of output scanline
	movzx	eax,word[I_END+22]
	dec	eax
	mul	ebp
	add	eax,ecx
	mov	edi,eax 	    ; edi points to last scanline

	mov	esi,I_END
	add	esi,[esi+10]
	mov	edx,[I_END+22]
	lea	eax, [ebp*2]
	mov	[delta], eax
	test	edx, edx
	jz	.ret
	jns	@f
	neg	edx
	mov	[delta], 0
	mov	edi, ecx
@@:
	movzx	eax,byte [I_END+28]
	shl	eax,16
	mov	al,24
	mov	[IMG_INFO_BitsPerPoint],eax
	shr	eax,16
	cmp	al,32
	jz	___bmp___convert32
	cmp	al,24
	jz	___bmp___convert24
	cmp	al,16
	jz	___bmp___convert15_init
	cmp	al,15
	jz	___bmp___convert15_init
	cmp	al,8
	jz	___bmp___convert8_init
	cmp	al,4
	jz	___bmp___convert4_init
	dec	eax
	jz	___bmp___convert1_init
.ret:
	pop	eax
	jmp	unsupported

;-------------------------------------------------------------------------------
___bmp___convert32:
	mov	[soi],esi
	movzx	ecx,word[IMG_INFO_Width]
	imul	ecx,edx 	    ;total count of pixels (edx contains height of the image)
	push	esi
	mov	edi,esi
___bmp___shrink32_loop:
	movsd
	dec	edi
	loop	___bmp___shrink32_loop
;-------------------------------------------------------------------------------
	push	edi		   ;edi points after the image data
	call	mem_resize_everything ;Free unnecessary memory
;-------------------------------------------------------------------------------

	pop	esi
___bmp___turnupsidedown_prepare:
	mov	ebx,edx
	shr	ebx,1		    ;ebx=(number of strings)/2
___bmp___turnupsidedown_do:
	push	edx
	mov	edi,edx
	dec	edi
	imul	edi,ebp
	add	edi,[soi]
	mov	ecx,ebp
	push	eax
___bmp___turnupsidedown_do_int:
	mov	al,[esi]
	xchg	al,[edi]
	mov	[esi],al
	cmpsb			    ;it's shorter than 'inc esi  inc edi'
	loop	___bmp___turnupsidedown_do_int
	pop	eax
	pop	edx
	dec	edx
	cmp	edx,ebx
	ja	___bmp___turnupsidedown_do
	ret

;-------------------------------------------------------------------------------
___bmp___convert15_init:
	call	___bmp___mem_resize_default
___bmp___convert15:
	mov	edi,ecx
	push	edi
	push	edi
	add	[esp],ebp
	movzx	ecx,word[IMG_INFO_Width]
	imul	ecx,edx
	mov	ebx,table5to8bits
___bmp___convert15_loop:
	cmp	[esp],edi
	ja	@f
	call	___bmp___align_input
	add	[esp],ebp
@@:
	lodsw			    ;/---16bits-----\
	shl	eax,3		    ;0BBBBBGGGGGRRRRR
	shr	al,3		    ;       ||
	xlatb			    ;       ||
	stosb			    ;       ||
	shr	eax,5		    ;       \/
	shr	al,3		    ;RRRRRRRRGGGGGGGGBBBBBBBB
	xlatb			    ;\--------24bits--------/
	stosb
	shr	eax,5
	shr	al,3
	xlatb
	stosb
	loop	___bmp___convert15_loop
	pop	eax    ;this is a better way of restoring stack than add esp,4
	pop	esi
	jmp	___bmp___turnupsidedown_prepare
;-------------------------------------------------------------------------------
___bmp___convert24:
;first stage - delete aligning gaps. Gap size = (4-scanline_size)&3
;second stage - flip the image upside-down if needed
	push	esi		   ;save start of image
	push	edx		   ;save height
	dec	edx		   ;we don't need to move first string
	jnz	@f
	ret			   ;no work if only one string
@@:
	push	4
	sub	[esp],ebp
	and	dword[esp],3	   ;[esp]=gap size

	mov	[soi],esi	   ;
	add	esi,ebp 	   ;we don't need to move first string
	mov	edi,esi 	   ;edi points after first scanline
;here begins the first stage loop
@@:
	add	esi,[esp]	   ;skip gap
	mov	ecx, ebp	   ;copy scanline
	rep	movsb		   ;edi will be OK
	dec	edx
	jnz	@b

	pop	edx		   ;now there are no gaps
	pop	edx		   ;restore height
	pop	esi		   ;restore start of image

	push	edi		   ;edi points after the image data
	call	mem_resize_everything ;Free unnecessary memory
	cmp	[delta],0
	jne	___bmp___turnupsidedown_prepare
	ret
;-------------------------------------------------------------------------------
___bmp___convert8_init:
	call	___bmp___mem_resize_default
___bmp___convert8:
	push	edi
	add	[esp], ebp
.loopi:
	xor	eax, eax
	lodsb
	cmp	byte[I_END+30],1
	jne	.nocompressed
.compressed:
	mov	ecx, eax
	jecxz	.special
	lodsb
	mov	eax, [ebx+eax*4]
@@:
	call	___bmp___put_pixel
	loop	@b
	jmp	.loopi
.nocompressed:
	cmp	byte[I_END+30],3   ;os/2 style
	jbe	.nocompressed1
	lea	eax,[eax+eax*2]
	mov	eax,[eax+ebx]
	jmp	.nocompressed11
.nocompressed1:
	mov	eax,[ebx+eax*4]
.nocompressed11:
	call	___bmp___put_pixel
.loopicont:
	cmp	edi, [esp]
	jb	.loopi
.next:
	pop	edi
	sub	edi, [delta]
	mov	eax, ebp
	and	eax, 3
	add	esi, eax
	dec	edx
	jnz	___bmp___convert8
	ret
.special:
	lodsb
	test	al, al
	jz	.next
	cmp	al, 2
	jbe	.end
	mov	ecx, eax
	push	ecx
@@:
	xor	eax, eax
	lodsb
	mov	eax, [ebx+eax*4]
	call	___bmp___put_pixel
	loop	@b
	pop	ecx
	and	ecx,1
	add	esi,ecx
	jmp	.loopi
.end:
	pop	edi
	ret
;-------------------------------------------------------------------------------
___bmp___convert4_init:
	call	___bmp___mem_resize_default
___bmp___convert4:
	push	edi
	add	[esp],ebp
___bmp___loopi_4:
	xor	eax,eax
	lodsb
	cmp	byte[I_END+30],2
	jne	___bmp___no_bi_rle4
___bmp___compressed_bi_rle4:
	mov	ecx,eax
	jecxz	___bmp___absolute_mode_bi_rle4
	inc	esi
@@:
	dec	esi
	xor	eax,eax
	lodsb
	shr	eax,4
	mov	eax,[ebx+eax*4]
	call	___bmp___put_pixel
	dec	ecx
	jz	___bmp___loopi_4
	xor	eax,eax
	dec	esi
	lodsb
	and	al,0xF
	mov	eax,[ebx+eax*4]
	call	___bmp___put_pixel
	loop	@b
	jmp	___bmp___loopi_4
___bmp___no_bi_rle4:
	shr	eax,4
	cmp	byte[I_END+30],3   ;os/2 style
	jbe	.nocompressed01
	lea	eax,[eax+eax*2]
	mov	eax,[eax+ebx]
	jmp	.nocompressed011
.nocompressed01:
	mov	eax,[ebx+eax*4]
.nocompressed011:
	call	___bmp___put_pixel
	cmp	edi,[esp]
	je	___bmp___loopidone_4
	xor	eax,eax
	dec	esi
	lodsb
	and	al,0xF
	cmp	byte[I_END+30],3   ;os/2 style
	jbe	.nocompressed001
	lea	eax,[eax+eax*2]
	mov	eax,[eax+ebx]
	jmp	.nocompressed0011
.nocompressed001:
	mov	eax,[ebx+eax*4]
.nocompressed0011:
	call	___bmp___put_pixel
___bmp___maybe_new_string_4:
	cmp	edi,[esp]
	jb	___bmp___loopi_4
___bmp___loopidone_4:
	pop	edi
	sub	edi,[delta]
	call	___bmp___align_input
	dec	edx
	jnz	___bmp___convert4
	ret
___bmp___absolute_mode_bi_rle4:
	lodsb
	test	al,al
	jnz	@f
	pop	edi
	sub	edi,[delta]
	dec	edx
	jnz	___bmp___convert4
	ret
@@:
	cmp	al,2
	ja	@f
	pop	edi
	ret
@@:
	mov	ecx,eax
@@:
	xor	eax,eax
	lodsb
	shr	eax,4
	mov	eax,[ebx+eax*4]
	call	___bmp___put_pixel
	dec	ecx
	jz	___bmp___absolute_mode_bi_rle4_unpack_end
	dec	esi
	xor	eax,eax
	lodsb
	and	al,0xF
	mov	eax,[ebx+eax*4]
	call	___bmp___put_pixel
	loop	@b
___bmp___absolute_mode_bi_rle4_unpack_end:
	push	esi		    ;align by a word boundary
;       sub     esi, I_END ;now is properly aligned
	sub	esi, [I_END+10]
	and	esi,1
	add	[esp],esi
	pop	esi
	jmp	___bmp___loopi_4
;-------------------------------------------------------------------------------
___bmp___convert1_init:
	call	___bmp___mem_resize_default
___bmp___convert1:
	push	edi
	add	[esp], ebp
.loopi:
	lodsb
	mov	ecx, 8
.loopii:
	add	al, al
	push	eax
	setc	al
	movzx	eax, al
	cmp	byte[I_END+30],3   ;os/2 style
	jbe	.nocompressed1001
	lea	eax,[eax+eax*2]
	mov	eax,[eax+ebx]
	jmp	.nocompressed10011
.nocompressed1001:
	mov	eax,[ebx+eax*4]
.nocompressed10011:
	call	___bmp___put_pixel
	pop	eax
	cmp	edi, [esp]
	loopnz	.loopii
	jnz	.loopi
	pop	edi
	sub	edi, [delta]
	call	___bmp___align_input
	dec	edx
	jnz	___bmp___convert1
	ret
;-------------------------------------------------------------------------------
___bmp___align_input:
	push	esi
;       sub     esi, I_END ;now is properly aligned
	sub	esi, [I_END+10]
	neg	esi
	and	esi, 3
	add	[esp], esi
	pop	esi
	ret

___bmp___put_pixel:
	push	eax
	stosw
	shr	eax,16
	stosb
	pop	eax
	ret

___bmp___mem_resize_default:
;This is a temporal solution of memory managing in bmp decoder
;It'll be changed when I'll make bmp decoder as new decoders - not to convert
;everything to 24bpp image but to produce output for 65th function.
;I.e. images with bpp<=8 will be converted to images with bpp=8 with palette,
;16bpp images will be converted to 24bpp with best rounding (tell me if you
;disagreed, _8bit_sample = _5bit_sample*255/31), 32 and 24bpp images' data
;left unchanged, only flipped vertically (if needed)
	push	edi
	add	[esp],ebp
	call	mem_resize_everything
	ret
