;-------------------------------------------------------------------------------
;The main part is written by Nable, it took me only one day, 24.06.2007, but
;there were some unsuccesful attempts a week before.
;I used only hands, head, small documentation and of course my paper notepad and
;a pen!
;To be continued...
;-------------------------------------------------------------------------------
;PCX_Hdr struc
;  pcxhmanufact  db ?          ;+0 ;manufacturer, must be 0ah
;  pcxhversion   db ?          ;+1 ;version, >= 5 for 8bit_per_sample color
;  pcxhencoding  db ?          ;+2 ;encoding,if 1 - file is encoded using RLE
;  pcxhbitsppix  db ?          ;+3 ;bits per sample (not per pixel)
;  pcxhxmin      dw ?          ;+4 ;x min dimension (usually 0)
;  pcxhymin      dw ?          ;+6 ;y min dimension (usually 0)
;  pcxhxmax      dw ?          ;+8 ;x max (width = xmax-xmin+1)
;  pcxhymax      dw ?          ;+10;y max (height = ymax-ymin+1)
;  pcxhhres      dw ?          ;+12;height of sourse device (useless)
;  pcxhvres      dw ?          ;+14;width of sourse device (useless)
;  pcxhpalette   db 48 dup (?) ;+16;16 color palette
;  pcxhresv1     db ?          ;+64;reserved
;  pcxhcplanes   db ?          ;+65;color planes, 1 for 256 color
;  pcxhbspline   dw ?          ;+66;bytes per unpacked line
;  pcxhpaltype   dw ?          ;+68;1 = greyscale, 2 = color
;  pcxhresv2     db 58 dup (?) ;+70;reserved
;-------------------------------------------------------------------------------
decode_pcx:
   push 0x580000
   call mem_resize_everything  ;Sorry, no memory-managing for pcx-unpacker yet.

   mov	esi,eax
   mov	edi,eax
;image is unpacked in two stages: unpacking and forming a 24bpp bitmap
   add	edi,[IMG_INFO_FileSize];after first stage unpacked image will be located just after original
   mov	[soi],workarea ;ready bitmap will be here ('workarea')

;   push dword[I_END+4]        ;we don't care about minimal dimensions
;   pop  dword[IMG_INFO_Block] ;really it is needed only in animations (GIF)

   xor	eax,eax        ;eax will be height
   mov	ebx,eax        ;ebx will be width
   mov	edx,eax        ;clear edx for some tricks

   mov	eax,[esi+8]
   sub	eax,[esi+4]
   add	eax,1*65536+1
   movzx ebx,ax
   mov	[IMG_INFO_Sizes],eax
   shr	eax,16

   mov  dl,byte[esi+3] ;bits per point
   push	edx
   movzx edx,byte[esi+65] ;number of color planes
   imul	edx,[esp]
   shl	edx,16
   mov	dl,24
   mov	[IMG_INFO_BitsPerPoint],edx
   pop	edx

   sub	esi,-128       ;skip header

   cmp	dl,8	       ;8bpp with palette or 24bpp or something else
   je	convert_pcx256
   cmp	dl,4	       ;4bpp image
   je	convert_pcx16
;   dec  dl             ;1bpp image
;   jz   convert_pcx2

   jmp	unsupported
;-------------------------------------------------------------------------------
convert_pcx256:
   dec	byte[esi-128+65] ;number of color layers ('planes')
   jz	pcx_one_plane  ;one...
   jmp	pcx_3_planes   ;...or three?
pcx_one_plane:
   cmp	byte[edi-769],10
   jne	_pcx_8bpp_palette_ready
   pushad
   mov	ecx,768
   sub	edi,ecx
@@:
   shl	byte[edi],2
   inc	edi
   loop @b
   popad
_pcx_8bpp_palette_ready:
   push dword next_step_for_1_plane
unpack_pcx_prepare:
   dec	byte[I_END+2]  ;Compressed?
   jz	dont_return_from_pcx_unpacker
   add	edi,eax
   ret		       ;jmp  return_from_pcx_unpacker
dont_return_from_pcx_unpacker:
   mul	ebx	       ;eax = size of unpacked (not ready, only unpacked) image in bytes
   pop	edx	       ;some passes with return address
   push eax	       ;save eax into stack for further usage
   push edx	       ;some passes with return address
   mov	ebx,eax        ;save eax to ebx because we need eax to use lodsb/stosb
   mov	edx,edi        ;edx = address of end of image file
   add	ebx,edi        ;ebx now is a pointer to the end of unpacked image
   sub	edx,256*3      ;edx now is a pointer to the image palette
   xor	ecx,ecx
unpack_pcx_loop:
   lodsb	       ;get byte from file
   cmp	al,11000000b   ;if 2 highest bits are set, other 6 is counter
   jb	@f
   and	al,00111111b
   mov	cl,al
   lodsb	       ;and the next byte is data
   rep
@@:
   stosb	       ;in other way just copy data byte

   cmp	edi,ebx        ;is that all?
   jb	unpack_pcx_loop;no
return_from_pcx_unpacker:

   ret		       ;yes
next_step_for_1_plane:
   mov	esi,edi
   pop	ecx	       ;ecx = size of unpacked image in bytes
   sub	esi,ecx        ;esi = pointer to unpacked 8bpp image with palette
		       ;as far as you remember edx is a pointer to the palette
   mov	edi,workarea   ;we will convert to 24bpp RAW because of the broken 65th sysfunc
   xor	eax,eax
next_step_for_1_plane_loop:
   lodsb
   lea	eax,[eax+eax*2]
   mov	eax,[edx+eax]  ;replace data byte with 3-byte meaning from palette
   bswap eax
   shr	eax,8
   stosw
   shr	eax,16
   stosb
   loop next_step_for_1_plane_loop
   jmp	converted
;-------------------------------------------------------------------------------
pcx_3_planes:
   lea	eax,[eax+eax*2];24bpp=3*8bpp
   call unpack_pcx_prepare
   mov	[soi],edi
   pop	eax	       ;eax = unpacked image size in bytes
;   mov  [___EOI],eax
   neg	eax
   lea	esi,[edi+eax]
;   mov  edi,[soi]

;   xor  ebx,ebx
;   mov  ecx,ebx
;   mov  cx,[IMG_INFO_Height]
;   mov  bx,[IMG_INFO_Width]
   mov	ecx,[IMG_INFO_Sizes];some optimization
   movzx ebx,cx
   shr	ecx,16

   neg	ebx
   lea	esi,[esi+ebx*2]
   add	esi,ebx
   neg	ebx
;-------------------------------------------------------------------------------
;pcx_3_planes_rebuild rebuilds unpacked PCX image with 3 planes from store view:
;/--string width--\
;BBBBB........BBBBB\
;GGGGG........GGGGG|
;RRRRR........RRRRR|
;..................+-height*3
;BBBBB........BBBBB|
;GGGGG........GGGGG|
;RRRRR........RRRRR/
;
;to normal RAW: RGBRGBRGBRGB...
;-------------------------------------------------------------------------------
pcx_3_planes_rebuild:	       ;for(int i=Height; i>0; i--)
   push ecx		       ;{
   mov	ecx,ebx 	       ;   for(int j=Width; j>0; j--)
   lea	esi,[esi+ebx*2]        ;   {
pcx_3_planes_rebuild_internal: ;   RAW_Image[Height-i][(Width-j)*3]=RGB(unpacked_image_area[i*j],
   mov	al,[esi+ebx]	       ;   unpacked_image_area[i*j+2*Width],
   shl	eax,8		       ;   unpacked_image_area[i*j+Width]);
   mov	al,[esi+ebx*2]	       ;   }
   shl	eax,8		       ;};
   lodsb		       ;As you can see everything is very simple and clear in
   stosd		       ;Asm but huge and slow in C++ (?)
   dec	edi
   loop pcx_3_planes_rebuild_internal
   pop	ecx
   loop pcx_3_planes_rebuild
   jmp	converted
;-------------------------------------------------------------------------------
convert_pcx16:
   shr	eax,1	       ;4bpp=8bpp/2
   call unpack_pcx_prepare
   pop	ecx	       ;ecx = unpacked image size in bytes
   sub	edi,ecx
   mov	esi,edi
   mov	edi,[soi]

   mov	ecx,[IMG_INFO_Sizes]
   movzx edx,cx 	    ;edx=width
   shr	ecx,16		    ;ecx=height
   mov	ebp,edx
convert_pcx16_loop:
   xor	eax,eax
   lodsb
   shr	al,4
   call pcx16_put_pixel
   jz	@f
   dec	esi
   xor	eax,eax
   lodsb
   and	al,0xF
   call pcx16_put_pixel
   jnz	convert_pcx16_loop
@@:
   jecxz @f
   mov	edx,ebp
   loop convert_pcx16_loop
@@:
   jmp	converted
pcx16_put_pixel:
   mov	eax,[(I_END+16)+eax+eax*2]
   bswap eax
   shr	eax,8
   stosd
   dec	edi
   dec	edx
   ret