;-------------------------------------------------------------------------------
;Here are routines that are involved in scrolling support in MeView
;All code below is written by Nable
;
;Last changed: January 26, 2009
;-------------------------------------------------------------------------------
macro scroll_handlers {
scroll_image_large_step:
    mov  cl,al			; ASCII key's byte to cl
    mov  eax,[IMG_BEGIN_OFFSETS];eax=IMG_BEGIN_TopOFFSET*65536+IMG_BEGIN_LeftOFFSET
    ror  eax,16 ;eax=IMG_BEGIN_LeftOFFSET*65536+IMG_BEGIN_TopOFFSET
    sub  cl,183
    jz	 scroll_image_large_step_page_down ;if 183 key was PgDn else PgUp
    sub  ax,100
    jns  @f
    xor  ax,ax
@@:
    jmp  scroll_image_large_step_end
scroll_image_large_step_page_down:
    add  ax,100
scroll_image_large_step_end:
    mov  cx,[IMG_INFO_Height]
    cmp  ax,cx
    jb	 @f
    and  ax,cx
@@:
    ror  eax,16
    jmp  scroll_image_end
home_image:
    xor  eax,eax
    jmp  scroll_image_end	;need redraw to see result of scrolling
scroll_image:
    cmp  al,179 		;176<=al<=179
    ja	 still
    movzx ecx,al
    mov  eax,[IMG_BEGIN_OFFSETS];eax=IMG_BEGIN_TopOFFSET*65536+IMG_BEGIN_LeftOFFSET
    sub  cl,176 		;ecx==176? (scroll left)
    jnz  scroll_not_left
    sub  ax,scroll_speed
    jns  @f
    mov  ax,[IMG_INFO_Width]
    dec  eax
@@:
    jmp  scroll_image_end
scroll_not_left:
    dec  ecx			;ecx==177? (scroll down)
    jnz  scroll_not_down
    ror  eax,16
    add  ax,scroll_speed
    cmp  ax,[IMG_INFO_Height]
    jb	 @f
    xor  ax,ax
@@:
    ror  eax,16
    jmp  scroll_image_end
scroll_not_down:
    dec  ecx			;ecx==178? (scroll up)
    jnz  scroll_right		;else ecx==179 (scroll right)
    ror  eax,16
    sub  ax,scroll_speed
    jns  @f
    mov  ax,[IMG_INFO_Height]
    dec  eax
@@:
    ror  eax,16
    jmp  scroll_image_end
scroll_right:
    add  ax,scroll_speed
    cmp  ax,[IMG_INFO_Width]
    jb	 @f
    xor  ax,ax
@@:
scroll_image_end:
    mov  [IMG_BEGIN_OFFSETS],eax
    jmp  clear_client_area	;redraw client area to see result of scrolling
}
macro draw_scrolled_image {
   movzx eax,byte[IMG_INFO_BitsPerPoint]
   cmp	eax,15			;in case of 15bpp each pixel
   jne	@f				;is represented by 2 byte value
   inc	eax
@@:   
   push eax
   mov	eax,[IMG_BEGIN_OFFSETS];begin drawing from (ax) column and (eax shr 16) row
   mov	edx,[IMG_INFO_Left] ;edx=Top*65536+Left
   add	edx,50*65536+10	;(image_position_in_window) rol 16
   ror	edx,16			;edx=Left*65536+Top
   mov	ecx,[IMG_INFO_Width] ;ecx=Height*65536+Width
   movzx ebp,cx 		;ebp=Width
   imul ebp,[esp]		;ebp=sizeof(output_scanline) in bits
   add	ebp,7			;scanline consists of integer number of bytes
   shr	ebp,3			;ebp=sizeof(output_scanline)
   sub	cx,ax			;cx=width-delta_x
   mov	ebx,[temp_area+42] ;window width
   sub	ebx,10*2-1		;client area width
   cmp	cx,bx			;select minimum
   cmova  cx,bx 		;mov if above
   ror	ecx,16			;ecx=(Width-delta_x)*65536+Height
   movzx esi,cx 		;esi=Height
   xor	cx,cx
   inc	ecx				;ecx=(Width-delta_x)*65536+1
   ror	eax,16			;eax=delta_x*65536+delta_y
   sub	si,ax			;esi=Height-delta_y
   add	esi,50			;esi=Height-delta_y+top_image_offset_in_window
   mov	ebx,[temp_area+46] ;window height
   sub	ebx,8			;client area height
   cmp	esi,ebx 		;is output height more than client area height
   cmova esi,ebx		;mov if above
   mov	[end_y],esi
   movzx ebx,ax 		;ebx=delta_y
   imul ebx,ebp
   shr	eax,16			;eax=delta_x
   imul eax,[esp]		;eax=offset_in_scanline
   add	eax,7
   shr  eax,3
   add	ebx,eax
   add	ebx,[soi]		;ebx=address_of_first_pixel_for_output

   mov	eax,65			;eax=65 (put image)
   pop	esi				;clear stack variable
   movzx esi,byte[IMG_INFO_BitsPerPoint] ;and esi=bpp
   mov	edi,[___Palette]
@@:
   int	0x40
   add	ebx,ebp
   inc	edx
   cmp	dx,[end_y]
   jb	@b
}