;-------------------------------------------------------------------------------
;Originally picture browser by lisovin@26.ru, now it's Nable's project
;Modified by Ivan Poddubny - v.0.3
;Modified by Diamond - v.0.4
;Modified a lot by Nable - v.0.5, see docs
;Modified a lot by Nable - v.0.57, see docs
;Modified a lot by Nable - v.0.58, see docs
;KPCK unpacker added by Nable - v.0.59, see docs
;Now it can be executed under KlbrInWin - v.0.59a - Nable's fix
;Load the whole file - get file size via 70.5 before loading - v.0.59b -\
;Nable's fix - thanks to Diamond for advice about 70.5 sysfunction
;Image drawing code modified a bit - now image is not painted on the borders -\
;they are left, so interface looks a bit better - v0.59c
;Compile with FASM for Kolibri
;-------------------------------------------------------------------------------
;Some constants that must be here
mem equ ((I_END+4095) and (not 0xFFF)) ;req. amount of memory
use32
org 0
;-------------------------------------------------------------------------------
		db 'MENUET01'	   ;8 byte id
		dd 0x01 	   ;min os_ver req.
		dd START	   ;start of code
		dd IM_END	   ;size of image
_program_memory dd mem		   ;memory for app
_saved_esp	dd stack_top	   ;esp
		dd temp_area, 0x0  ;I_Param , I_Icon

include    'common.inc' 	   ;constants and common code
include    'lang.inc'
include    'memory.inc' 	   ;stuff for my memory model. Maybe you'll
				   ;like it, maybe not

include    'macros.inc' 	   ;note that I use _my_ macros.inc,
				   ;don't use the standard one.
;interface stuff
include    'intrface/GetPixel.inc' ;used in interface, for example, thumbnail creation
include    'intrface/scroll.inc'   ;drawing interface
include    'intrface/mvipccom.inc' ;IPC interface,'crtthumb.inc'is a part of it

;decoders
include    'decoders/gif_lite.inc'
include    'decoders/bmpdecod.inc' ;'icodecod.inc' is a part of 'bmpdecod.inc'
;include    'decoders/pcxdecod_new.inc'
include    'decoders/pcxdecod.inc'
include    'decoders/tgadecod.inc'
include    'decoders/z80decod.inc'
include    'decoders/unpacker.inc' ;unpacker of KPack'ed files

;threads
include    'threads/opendlg.inc'
include    'threads/infodlg.inc'
include    'threads/bgrddlg.inc'
;******************************************************************************

START:			    ;start of execution
   finit		    ;init fpu for using
   mov	 al,70		    ;load file with background settings
   mov	 bx,bgrfileinfo
   int	 0x40
;   cmp   al,6               ;do we need this error checking?
;   jz    bgrfile_ok
;   test  eax,eax
;   jz    bgrfile_ok
;   jmp   exit_application
bgrfile_ok:
   sub	 byte [bgrmode],'0' ;ASCII symbol -> number

   mov	 al,'>' 	    ;look for ending ASCII symbol '>'
   mov	 di,string	    ;in loaded string
   inc	 ch		    ;mov   ecx,256

   repne scasb
   dec	 edi
   xor	 eax,eax
   rep	 stosb

; check for parameters
   mov	 eax,temp_area
   mov	 ebx,[eax]
   mov	 [aMeViewMode],ebx
;   cmp   ebx,'IPCM'
;   je    IPC_mem

   cmp	 ebx,'IPCN'
   je	 IPC_name

   cmp	 bx,'TN'
   je	 IPC_name

   cmp	 ebx,'BOOT'
   jne	 .no_boot

   or	 byte[status],bootmode
   call  load_image
   call  background
   jmp	 exit_application

.no_boot:
   cmp	 byte [eax],0
   jz	 .no_param
   mov	 esi,eax
   mov	 edi,string
   inc	 ch		    ;strlen=256
   rep	 movsb		    ;copy string from temp_area to "string" (filename)

   call  load_image

.no_param:
   and	dword[pos],0
   or	ecx,-1		    ;get information about me
   call getappinfo

   mov	edx,[process_info+30] ; our ID is in EDX now
   mov	ecx,eax

@@:
   call getappinfo
   cmp	edx,[process_info+30]
   je	@f  ; if our PID equivalens the PID of currently testing process, we have found ourselves
	    ; else we test next process
   loop  @b ; return, if not all processes tested
@@:

; in ecx now our process #
    mov  [process],ecx

;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:
    or	 ecx,-1 		   ;get information about me
    call getappinfo		   ;
;    test dword[temp_area+70],2     ;test if window is minimized
;    jnz  draw_window.finish        ;if minimized we just finish
;    test dword[temp_area+70],4     ;test if window is collapsed to title
;    jz   draw_window.normally
;    mov  [temp_area+...
;

;    call GetStdColors              ;it's used only here, so it's not separated as a function
;GetStdColors:
    mov  al,48
    mov  ebx,3
    mov  ecx,system_colors
    mov  edx,40
    int  0x40
;    ret

    call BeginDraw
				   ;DRAW WINDOW
    xor  eax,eax		   ;function 0 : define and draw window
    mov  ebx,[temp_area+34]	   ;[x start]
    mov  ecx,[temp_area+38]	   ;[y start]
    shl  ebx,16 		   ;[x start] * 65536
    shl  ecx,16 		   ;[y start] * 65536
    add  ebx,[wnd_width]	   ;+ [x size]
    add  ecx,[wnd_height]	   ;+ [y size]
    mov  edx,[system_colors+20]    ;color of work area RRGGBB
    or	 edx,0x13000000 	   ;window_style 3
    mov  edi,labelt
    int  0x40

    mov  al,8
    mov  ebx,10*65536+46
    mov  ecx,25*65536+20
    mov  edx,2
    mov  esi,[system_colors+24]    ;button_color
newbutton:
    int  0x40
    add  ebx,48*65536
    inc  edx
    cmp  dl,6
    jb	 newbutton

    mov  al,4			   ;function 4 : write text to window
if (lang eq de)
    mov  ebx,22*65536+32
else
    mov  ebx,23*65536+32
end if
    mov  ecx,[system_colors+28]    ;text at button
    or	 ecx,0x80000000 	   ;ASCIIZ string, font 1 & color ( 0xF0RRGGBB )
    mov  dx,buttext
    int  0x40

clear_client_area:
    mov  eax,13
    mov  edx,[system_colors+20]    ;client area color

    mov  esi,[IMG_INFO_Sizes]
    sub  esi,[IMG_BEGIN_OFFSETS]
    movzx edi,si		   ;edi=img_displayable_width
    shr  esi,16 		   ;esi=img_displayable_height

    mov  ebx,[temp_area+42]	   ;ebx=WindowBoxWidth
    mov  ecx,[temp_area+46]	   ;ecx=WindowBoxHeight
    sub  ebx,10+10-1		   ;eval. image area (=client area) sizes
    sub  ecx,50+10-2
    push ebx
    push ecx
;at first, block that's right to the image
    sub  ebx,edi		   ;nothing to clear?
    jle  .block2

    push di			   ;calculate left offset of first block
    add  word[esp],10
    push bx
    pop  ebx

;cx already contains the needed value
    or	 ecx,50*65536		   ;and begin drawing under controls
    int  0x40
.block2:
    pop  ecx
    pop  ebx
    sub  ecx,esi		   ;height of second block=ClientBoxHeight-img_displayable_height
    jle  .end

    push si			   ;calculate top offset of second block
    add  word[esp],50
    push cx
    pop  ecx

    or	 ebx,10*65536		   ;skip left border, and width of second block = ClientBoxWidth
    int  0x40
.end:
draw_image:
    draw_scrolled_image
;draw_window.finish:
    call EndDraw

;And we are in main loop
still:
    test    byte[status],start_loading_file
    jnz     kopen
    mov     eax,[___img_count]
    dec     eax
    jle     .no_animation	;if we have only a single image (or nothing
				;at all) ___img_count is either 1 or 0

    mov     ebx,frame_num
    cmp     [ebx],eax
    jbe     @f
    or	    dword[ebx],-1
@@:
    inc     dword[ebx]
    call    GetGIFinfo		;[animation_handler]
    mov     eax,23
    mov     ebx,[IMG_INFO_Delay]
    int     0x40
    test    eax,eax
    jnz     .handle_event
    jmp     clear_client_area ;anti-blinking, redraw only image, not the whole window
.no_animation:
    mov     eax,10		; wait here for event
    int     0x40

.handle_event:
    dec     eax
    jz	    red
    dec     eax
    jnz     button

key:				; key
    mov  al,2
    int  0x40
    mov  al,ah
    cmp  al,6
    je	 kfile
    cmp  al,15
    je	 kopen
    cmp  al,9
    je	 kinfo
    cmp  al,2
    je	 kbgrd
    cmp  al,180
    je	 home_image
    cmp  al,184
    je	 scroll_image_large_step
    cmp  al,183
    je	 scroll_image_large_step
    cmp  al,176 		;176-179 - cursor keys
    jae  scroll_image
    jmp  still

    scroll_handlers		;I used macros here just to locate
    ;scroll handlers code here but the source in the separate file

red:
    test    byte[status],make_mainwin_active
    jz	    draw_window
    mov     al, 18
    mov     ebx, 3
    mov     ecx, [process]
    int     0x40
    and     byte[status],not make_mainwin_active
    jmp     still

button: 			; button
    mov  al,17			; get id
    int  0x40

    dec  ah			; button id==1 ?
    jnz  noclose
exit_application:
    or	 eax,-1 		; close this program
    int  0x40

noclose:
;    xor  ebx,ebx
    dec  ah			; button id==2 ?
    jnz  nofile
kfile:
    test byte[status],file_window_opened
    jnz  still
    or	 byte[status],file_window_opened
    mov  ecx,thread1
    mov  edx,stack_for_thread1
    jmp  StartThread

nofile:
    dec  ah			; button id==3 ?
    jnz  noopen
kopen:
    and  byte[status],not start_loading_file
    or	 ecx,-1
    call getappinfo
    call load_image
    jmp  still

noopen:
    dec  ah			; button id==4 ?
    jnz  noinfo
kinfo:
    test byte[status],info_window_opened
    jnz  still
    or	 byte[status],info_window_opened
    mov  ecx,thread2
    mov  edx,stack_for_thread2
    jmp  StartThread

noinfo:
    dec  ah			; button id==5 ?
    jnz  still
kbgrd:
;Set background
    test byte[status],sbgr_window_opened
    jnz  still
    or	 byte[status],sbgr_window_opened
    mov  ecx,thread3
    mov  edx,stack_for_thread3
StartThread:
    mov  eax,51
    mov  ebx,1
    int  0x40
    jmp  still

getappinfo:
    mov  eax,9
    mov  ebx,process_info
    int  0x40
    ret

BeginDraw:
    mov  ebx,1			   ;1, start of draw
    jmp  EndDraw.tell_about_window_draw
EndDraw:
    mov  ebx,2			   ;2, end of draw
EndDraw.tell_about_window_draw:
    mov  eax,12 		   ;function 12:tell os about windowdraw
    int  0x40
    ret

load_image:
;    and     byte[status],not use_65th
    xor     eax,eax		     ;clear some data, that may crash the
    mov     edi,variables	     ;application if not zeroed
    mov     ecx,(___clean_up_to_here-variables)/4
    rep     stosd
;at first, we get file size via 70.5 function
;then we allocate memory and load the file
    mov     eax,70
    mov     ebx,_main_fileinfo
    mov     byte[ebx],5 	     ;_main_fileinfo.command
    sub     esp,40
    mov     [ebx+16],esp	     ;_main_fileinfo.dest
    int     0x40
    add     esp,40

    test    eax,eax		     ;fs error occured?
    jnz     unsupported
    test    byte[esp-40],(0x10+0x8)  ;exit if it's not a file
    jnz     unsupported

    mov     ebx,_main_fileinfo
    and     dword[ebx],0	     ;_main_fileinfo.command
    mov     eax,[esp+32-40]	     ;file size
    mov     [ebx+12],eax	     ;_main_fileinfo.count
    mov     dword[ebx+16],I_END      ;_main_fileinfo.dest
    add     eax,I_END+4096	     ;statical area size + one page for reserve
    push    eax
    call    mem_resize_everything    ;allocate needed memory

    mov     eax,70		     ;no error checking here - if we got
    int     0x40		     ;file attributes then it's readable

.file_loaded:
    mov     eax,I_END
    mov     ebx,[IMG_INFO_FileSize]
    lea     edi,[eax+ebx+4096]
    and     edi,not (0xFFF)
    mov     [___cur_info],edi	    ;[___cur_info] - pointer to output area

.convert:
    cmp     dword[eax],'KPCK'	    ;test if file was KPack'ed
    jnz     .not_kpacked
    mov     ecx,[eax+4] 	    ;original file size
    push    ecx 		    ;save it for the further use

    push    ecx 		    ;and push as a parameter for alloc
    add     [esp],edi
    call    mem_add_pages	    ;do alloc

    push    edi 		    ;where to unpack
    push    eax 		    ;from where to unpack
    call    KolibriStdPackerUnpack

    pop     ecx 		    ;shrink original file
    mov     esi,[___cur_info]
    mov     edi,eax		    ;function saves everything
    rep     movsb
    jmp     .convert		    ;file could be packed multiple times
				    ;and/or with different packers
.not_kpacked:
    cmp     word[eax],'BM'	    ;Nable's comment:
    je	    decode_bmp		    ;Here we can add new image types

    cmp     dword[eax],'GIF8'	    ;and entry points to their decoders
    je	    ReadGIF

    cmp     byte[eax],0x0A	    ;PCX signature
    je	    decode_pcx
;here I detect if it is a DIB icon or cursor image
    cmp     byte[eax+16],2;In tga this byte keeps bpp, and in cursor this byte
    ja	    .not_a_cursor ;is <=2. I spent almost the half of an hour to find
			;this way to differ TGA and CUR(ICO)
		       ;Why there are no signatures in TGA and ICO/CUR files?!
    cmp     dword[eax],0x10000	    ;ICO, bitmap type 1 (or 8bit TGA)
    je	    decode_ico
    cmp     dword[eax],0x20000	    ;CUR, bitmap type 2, but it also can be
    je	    decode_ico		    ;a colored TGA
.not_a_cursor:
;now, its time to probe if it is a TGA file
    mov     ecx,[eax+1] 	    ;cl=cmatype,ch=subtype
    cmp     cl,1		    ;cmatype is either 0 or 1
    ja	    .not_a_tga
    cmp     ch,11		    ;subtype is 1..3 (non-rle) or 9..11 (rle)
    ja	    .not_a_tga
    mov     edx,[eax+16]	    ;dl=bpp, dh=flags //image descriptor
    cmp     dl,8
    jb	    .not_a_tga		    ;bpp must be 8, 15, 16, 24 or 32
    cmp     dl,32
    ja	    .not_a_tga
    test    dl,111b
    jnz     .maybe_tga15
.continue_testing_for_tga:
;you can add some tests for TGA here
    jmp     decode_tga
.maybe_tga15:
    cmp     dl,15
    jne     .not_a_tga
    inc     dl
    jmp     .continue_testing_for_tga
.not_a_tga:
;if no signatures, signs and anything else, maybe it's a Z80 snapshot?
;valid sizes are 6912 and 6929
    cmp     ebx,6912
    je	    decode_z80
    cmp     ebx,6929
    je	    decode_z80
unsupported:
    pop     eax 		    ;restore stack instead of 'ret'
				    ;because we need another return address
				    ;because it's an unsupported image type
    test    byte[status],bootmode
    jz	    still		    ;if not in bootmode we go to main loop,
    jmp     exit_application	    ;if in bootmode we exit

converted:
;Setup common pointers to functions according to bpp
    movzx   eax,word[IMG_INFO_BitsPerPoint]
;    test    byte[status],use_65th
;    jnz     @f
;    mov     eax,24
;@@:
    mov     ebx,Prepare2Get.Ratio+4 ;and so: &[Prepare2Get.Ratio]==ebx-4, &[GetPixel]==ebx
    cmp     eax,32
    jb	    @f
    mov     dword[ebx],GetPixel.32bpp
    jmp     .functions_set
@@:	
    cmp     eax,24
    jb	    @f
    mov     dword[ebx],GetPixel.24bpp
    jmp     .functions_set
@@:	
    cmp     eax,16
    jb	    @f
    mov     dword[ebx],GetPixel.16bpp
    jmp     .functions_set
@@:	
    cmp     eax,15
    jb	    @f
    mov     dword[ebx],GetPixel.15bpp
    inc     eax
    jmp     .functions_set
@@:	
    cmp     eax,8
    jb	    unsupported
    mov     dword[ebx],GetPixel.8bpp
.functions_set:
    shr     eax,3
    mov     [ebx-4],eax
;Setup common settings
    test byte[status],bootmode
    jnz  converted.no_draw
    mov  esi,[IMG_INFO_Sizes]	    ;Sizes
    add  esi,[IMG_INFO_Block]	    ;Offsets
    movzx  edx,si
    shr  esi,16
@@:
    add  edx,20
    cmp  edx,210
    jae  @f
    mov  edx,210
@@:
    add  esi,58 		    ;place for controls and borders

    or	ecx,-1			    ;get information about me
    call getappinfo
;GetScreenWorkArea: ;it's used only here, so it's not separated as a function
    mov  eax,48
    mov  ebx,5
    int  0x40
;check if we fit in screen work area
    movzx ecx,ax		    ;ecx=right
    movzx edi,bx		    ;edi=bottom
    shr   eax,16		    ;eax=left
    shr   ebx,16		    ;ebx=top
    sub   ecx,eax		    ;ecx=GetScreenWorkArea.width
    sub   edi,ebx		    ;edi=GetScreenWorkArea.height
    cmp   edx,ecx
    cmova edx,ecx		    ;if(edx>ecx) edx=ecx //limit width
    cmp   esi,edi
    cmova esi,edi		    ;if(esi>edi) esi=edi //limit height

    movsx ebp,word[process_info+34] ;ebp=current y
    cmp   ebp,ebx		    ;test if window is too high
    jle   .test_y_coord 	    ;if yes, move it lower (ebx is already == top)
    add   edi,ebx
    cmp   ebp,edi		    ;may be it's too low?
    jge   .test_y_coord
    or	  ebx,-1		    ;and if fits - then leave as is
.test_y_coord:			    ;now ebx contains needed value and edi is free, we'll use it
    movsx edi,word[process_info+38]
    cmp   edi,eax		    ;test if window is too left
    cmovle ecx,eax		    ;if yes, move it right
    jle   .do_resize
    add   eax,ecx
    cmp   edi,ecx		    ;may be it's too right?
    cmovge  ecx,eax
    jge   .do_resize
    or	  ecx,-1
.do_resize:
    mov  [wnd_width],edx
    mov  [wnd_height],esi
    mov  eax,67 		   ;function 67: move/resize window
    int  40h
.no_draw:
    ret

; DATA AREA
wnd_width  dd 210
wnd_height dd 58

lsz buttext,\
    en,   'FILE    OPEN    INFO    BGRD',\
    ru,   '            ',\
    de,   'DATEI  OEFNEN   INFO    HGRD'

pos: dd 6
___table_ptr	dd hashtable

bgrfileinfo:
     dd 0
     dd 0
     dd 0
     dd 257
     dd string-1
bgrinfo_filename:
     db      '/sys/backgrnd.ini',0

_main_fileinfo:
_main_fileinfo.command	dd 0
_main_fileinfo.pos_low	dd 0
_main_fileinfo.pos_high dd 0
IMG_INFO_FileSize: ;they are the same, really
_main_fileinfo.count	dd 0
_main_fileinfo.dest	dd I_END ;where to read to
			db 0
_main_fileinfo.path	dd string

;_main_BDVK: may be later I'll read info from 70.5 not to
;stack but to structure here and in the info window you'll
;see the file information

labelt:
	 db 'MeView v.0.59c -'
IM_END: 		    ;here begins uninited data
bgrmode 	       rb 1
string:
     rb 257

status		       rb 1 ;see the meanings of bits at the const.inc

align 4
aMeViewMode	       rd 1
process 	       rd 1 ;our main process slot number

variables:
;don't insert anything between these 2 pointers - they are located
;so for optimization (we can address them using only one register)
Prepare2Get.Ratio  rd 1  ;pointer to function
GetPixel	       rd 1  ;pointer to function

;ScreenWorkArea.left_right rd 1
;ScreenWorkArea.top_bottom rd 1

frame_num:			   rd 1
IMG_BEGIN_OFFSETS:
IMG_BEGIN_LeftOFFSET:  rw 1
IMG_BEGIN_TopOFFSET:   rw 1

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Don't edit this structure.
IMG_INFO_Block: 	   ; It is used directly by many parts of the program.
IMG_INFO_Left:	       rw 1; If you want something to add, then add it to the
IMG_INFO_Top:	       rw 1; end of the structure.
IMG_INFO_Sizes: 	   ;
IMG_INFO_Width:        rw 1;
IMG_INFO_Height:       rw 1;
IMG_INFO_Delay	       rd 1;
IMG_INFO_Displacement  rd 1;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

IMG_INFO_BitsPerPoint: rw 1	;<- this value is used for image output
IMG_INFO_BitsPerPointReal: rw 1 ;<- and this is the real bpp of current image

align 4

soi			rd 1 ;start of image
thumbnail	rd 1 ;offset of thumbnail of the image, may be NULL
thumbnail_size rd 1 ;width+height*65536
thumbnail_mem  rd 1 ;size of thumbnail

end_y:
delta		rd 1 ;delta between two row positions

output_data_size rd 1
pFormatDetected rd 1
;decoders' variables. Variables change their roles
;depend to decoders for memory saving & speed
___raw_size	rd 1

tga_block_count:
___globalColor	rd 1

___img_count	rd 1

start_of_img_data:
___img_start	rd 1

tga_file_information1:
label tga_pixel_size  byte at (tga_file_information1+0)
label tga_image_flags byte at (tga_file_information1+1)
label tga_cmatype     byte at (tga_file_information1+2)
label tga_subtype     byte at (tga_file_information1+3)
___codesize	rd 1

current_pixel:
___compsize	rd 1

dup_pixel_count:
___bit_count	rd 1

___CC		rd 1
___EOI		rd 1
___Palette	rd 1
___block_ofs	rd 1

___cur_info	rd 1 ;image table pointer

___row_end	rd 1
___img_end	rd 1
___pass 	rd 1
___width	rd 1
___anim_delay	rd 1
___anim_disp	rd 1


process_info:
temp_area:
     rb 0x400
system_colors:
     rb 40

___clean_up_to_here:

     rd 8    ;<------+
stack_for_thread1: ;-+

     rd 4    ;<------+
stack_for_thread2: ;-+

     rd 4    ;<------+
stack_for_thread3: ;-+

     rd 0x400		     ;huge stack needed for huge files
stack_top:
     rd 1

hashtable: rd (hash_area_size/4) ;hash area for unpackers
I_END:
