;-------------------------------------------------------------------------------
;This thread of MeView application is a window that allows you to
;set opened file as a background.
;Keys KEY_UP and KEY_DOWN - select mode (also you can press
;the buttons). 'Return' key (or 'OK' button) - set background and 
;terminate this thread, 'Escape' - just terminate the thread.
;
;Last changed: January 26, 2009
;-------------------------------------------------------------------------------
thread3:			  ; start of bgrd thread

;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


.draw_window:
    call BeginDraw
				   ;DRAW WINDOW
    xor  eax,eax		   ;function 0 : define and draw window
    mov  ebx,100*65536+200	   ;[x start] *65536 + [x size]
    mov  ecx,100*65536+100	   ;[y start] *65536 + [y size]
    mov  edx,[system_colors+20]    ;color of work area RRGGBB
    add  edx,0x14000000 	   ;window_style 4
    mov  edi,thread3.labelt
    int  0x40

    mov  al,8
    mov  ebx,70*65536+40
    mov  ecx,70*65536+20
    mov  edx,4
    mov  esi,[system_colors+24]    ;button_color
    int  0x40

    mov  al,4			   ;function 4 : write text to window
    mov  ebx,46*65536+28	   ;[x start] *65536 + [y start]
    mov  ecx,[system_colors+32]    ;text in the workarea
    add  ecx,0x80000000 	   ;ASCIIZ string, font 2 & color 0xF0RRGGBB
    mov  dx,thread3.bgrdtext
    int  0x40
    add  ebx,40*65536+15
    mov  dx,thread3.tiled
    int  0x40
    add  bl,15
    mov  dx,thread3.stretch
    int  0x40
    add  bl,18
    mov  ecx,[system_colors+28]    ;text at button
    add  ecx,0x80000000 	   ;ASCIIZ string, font 2 & color 0xF0RRGGBB
    mov  dx,thread3.ok_btn
    int  0x40

    call thread3.drawflags

    call EndDraw

.still:

    mov  eax,10 		; wait here for event
    int  0x40

    dec  eax			; redraw request ?
    jz	 thread3.draw_window
    dec  eax			; key in buffer ?
    jz	 thread3.key
				;else it's button event
.button:			; button
    mov  al,17			; get id
    int  0x40

    cmp  ah,1			; button id=1 ?
    jne  thread3.noclose
.close:
    and  byte[status],not sbgr_window_opened
    or	 byte[status],make_mainwin_active
    or	 eax,-1 		; close this program
    int  0x40
.noclose:
    cmp  ah,4
    jne  thread3.nook
.kok:
    call background
    jmp  thread3.close
.nook:
    cmp  ah,3
    ja	 thread3.still
    dec  ah
    mov  byte [bgrmode],ah
.flagcont:
    call thread3.drawflags
    jmp  thread3.still

.key:
    mov  al,2
    int  0x40
    cmp  ah,27
    je	 thread3.close
    cmp  ah,13
    je	 thread3.kok
    cmp  ah,178 ;up
    jne  thread3.nofup
    cmp  byte [bgrmode],1
    je	 thread3.fdn
.fup:
    dec  byte [bgrmode]
    jmp  thread3.flagcont
.nofup:
    cmp  ah,177 ;down
    jne  thread3.still
    cmp  byte [bgrmode],2
    je	 thread3.fup
.fdn:
    inc  byte [bgrmode]
    jmp  thread3.flagcont

.drawflags:
    mov  eax,8
    mov  ebx,70*65536+10
    mov  ecx,40*65536+10
    mov  edx,2
    mov  esi,[system_colors+24]    ;button_color
    int  0x40
    add  ecx,15*65536
    inc  edx
    int  0x40
    mov  al,4
    mov  ebx,73*65536+42
    mov  ecx,[system_colors+28]    ;text at button
    mov  dx,thread3.vflag
    xor  esi,esi
    inc  esi
    cmp  byte [bgrmode],1
    je	 thread3.nodownflag
    add  bl,15
.nodownflag:
    int  0x40
.loc_ret:
    ret

; ⠭ 䮭
background:
    mov  eax,15
    xor  ebx,ebx			;mov  ebx,1
    inc  ebx
    mov  edx,[IMG_INFO_Sizes] ;edx=Height*65536+Width ;Some optimization
    test edx,edx
    jz	 thread3.loc_ret	;nearest loc_ret
    movzx ecx,dx
    shr  edx,16
    int  0x40

	mov  edi,ecx
	imul edi,edx			;edi=Width*Height //counter
	inc  ebx				;ebx=2
	xor  ecx,ecx
    mov  esi,[soi]
	mov  ebp,[___Palette]
@@:	
	xchg eax,edx			;must be only one byte!
	call [GetPixel]
	xchg eax,edx			;must be only one byte!
	int  0x40
	add  ecx,3
	dec  edi
	jnz  @b

    inc  ebx
    inc  ebx				;ebx=4 (set mode: tile/stretch)
    movzx ecx,byte[bgrmode]
    int  0x40

    dec  ebx
    int  0x40
    ret

;-------------------------------------------------------------------------------
; DATA AREA
;-------------------------------------------------------------------------------
thread3.vflag: db 'X'

lsz thread3.labelt,\
    en, 'Background set',\
    ru, '⠭ 䮭',\
    de, 'Hintergrund gesetzt'

lsz thread3.bgrdtext,\
    en, 'SET AS BACKGROUND:',\
    ru, ' ਬ:',\
    de, 'ALS HINTERGRUND:'

lsz thread3.tiled,\
    en, 'TILED',\
    ru, '',\
    de, 'GEKACHELT'

lsz thread3.stretch,\
    en, 'STRETCH',\
    ru, '',\
    de, 'GESTRECKT'

thread3.ok_btn:
    db 'OK',0
