;-------------------------------------------------------------------------------
;This thread of MeView application is a window that edits the full path to
;the file that must be opened. This path is at 'string' label.
;When the 'Return' key had been hit, this thread closes and main thread
;of MV openes specified file (if possible). If 'Esc' key - then only this
;thread is closed.
;
;Last changed: October 28, 2008
;-------------------------------------------------------------------------------

thread1:			   ; start of thread1
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
draw_window1:
    call BeginDraw
				   ; DRAW WINDOW
    xor  eax,eax		   ; function 0 : define and draw window
    mov  ebx,100*65536+300	   ; [x start] *65536 + [x size]
    mov  ecx,100*65536+80	   ; [y start] *65536 + [y size]
    mov  edx,[system_colors+20]    ; color of work area RRGGBB
    add  edx,0x14000000 	   ; window_style 4
    mov  edi,labelt1		   ; pointer to text beginning
    int  0x40

    call drawstring

    call EndDraw

still1:

    mov  eax,10			; wait here for event
    int  0x40

    dec  eax			; redraw request ?
    jz	 thread1
    dec  eax			; key in buffer ?
    jz	 key1
    dec  eax			; button in buffer ?
    jz	 button1

    jmp  still1

key1:				; key
    mov  al,2
    int  0x40
    cmp  ah,179
    jne  noright
    cmp  dword[pos],253
    ja	 still1
    inc  dword [pos]
    call drawstring
    jmp  still1
noright:
    cmp  ah,176
    jne  noleft
    mov  eax,[pos]
    test eax,eax
    jz	 still1
    dec  eax
    mov  [pos],eax
    call drawstring
    jmp  still1
noleft:
    cmp  ah,182        ;del
    jne  nodelet
    call shiftback
    call drawstring
    jmp  still1
nodelet:
    cmp  ah,8	       ;backspace
    jne  noback
    mov  eax,[pos]
    test eax,eax
    jz	 still1
    dec  eax
    mov  [pos],eax
    call shiftback
    call drawstring
    jmp  still1
noback:
    cmp  ah,13
    je	 close1

    cmp  ah,27	       ;escape
    je	 close1_1

    cmp  dword [pos],254
    jae  still1

    mov  edi,string+254
    mov  esi,edi
    dec  esi
    mov  ecx,254
    sub  ecx,[pos]
    std
    rep  movsb
    cld

    shr  eax,8
    mov  esi,string
    add  esi,[pos]
    mov  byte [esi],al
    inc  dword [pos]
    call drawstring

    jmp  still1

button1:			; button
    mov  al,17			; get id
    int  0x40

    dec  ah			; button id==1 ?
    jnz  noclose1
    jmp  close1
close1:
    or	 byte[status],(make_mainwin_active+start_loading_file)
close1_1:
    and  byte[status],not file_window_opened
    or	 eax,-1 		; close this program
    int  0x40
noclose1:
    dec  ah			; button id==2 ?
    jnz  still1
    mov  al,37
    mov  ebx,1
    int  0x40
    shr  eax,16
    xor  edx,edx
    mov  bl,6
    div  ebx
    mov  [pos],eax
    call drawstring
    jmp  still1


shiftback:
    mov  edi,string
    add  edi,[pos]
    mov  esi,edi
    inc  esi
    xor  ecx,ecx	    ;mov  ecx,255
    dec  cl
    sub  ecx,[pos]
;    cld
    rep movsb
    ret

drawstring:
    pushad
    mov  eax,8		    ;invisible button
    mov  ebx,5*65536+256*6
    mov  ecx,40*65536+15
    mov  edx,0x60000002
    int  0x40

    mov  al,13		    ;bar
    mov  edx,[system_colors+24] ;button_color
    int  0x40

    mov  ebx,6*65536	    ;cursor
    imul ebx,dword [pos]
    add  ebx,5*65536+6
    mov  edx,0x6A73D0
    int  0x40
    mov  al,4		    ;path
    mov  ebx,5*65536+44
    mov  ecx,[system_colors+28]    ;text at button
    mov  edx,string
    mov  esi,255
    int  0x40

    popad
    ret

; DATA AREA

lsz labelt1,\
   en,	'Open...',\
   ru,	'...',\
   de,	'Oefnen...'

