;-------------------------------------------------------------------------------
;Common constants
;-------------------------------------------------------------------------------
workarea	equ 0x200000
hash_area_size	equ 4096*8
scroll_speed	equ 4
;Status bits:--------------------+
file_window_opened  equ 1  ;bit0 |
info_window_opened  equ 2  ;bit1 |
make_mainwin_active equ 4  ;bit2 |
sbgr_window_opened  equ 8  ;bit3 |
			   ;bit4 |
bootmode	    equ 32 ;bit5 |
;use_65th	    equ 64 ;bit6 |
start_loading_file  equ 128;bit7 |
;--------------------------------+
;-------------------------------------------------------------------------------
table5to8bits:;this table is used to expand from 5 to 8 bits with best rounding.
db 0,8,16,24,32,41,49,57,65,74,82,90,98,106,115,123,131,139,148,156,164,172,180,189,197,205,213,222,230,238,246,255

_16color_palette:
dd	0		; black
dd	0x000000b0	; blue
dd	0x00b00000	; red
dd	0x00b000b0	; magenta
dd	0x0000b000	; green
dd	0x0000b0b0	; cyan
dd	0x00b0b000	; yellow
dd	0x00b0b0b0	; gray
dd	0		; black
dd	0x000000ff	; light blue
dd	0x00ff0000	; light red
dd	0x00ff00ff	; light magenta
dd	0x0000ff00	; light green
dd	0x0000ffff	; light cyan
dd	0x00ffff00	; light yellow
dd	0x00ffffff	; white
;-------------------------------------------------------------------------------
write_16color_palette:
;in: edi - where to write
;The routine modifies edi in obvious way - after return edi points after the
;written palette. It's more useful than harmful.
;Take care of memory, routine doesn't do any checks.
    push ecx esi
    mov  esi,_16color_palette
    mov  ecx,16
    rep  movsd
    pop  esi ecx
    ret

;-------------------------------------------------------------------------------
make_palette_32:
;ecx = number of entries in colormap
;[___Palette] this pointer needs no comments :)
;0xBBGGRR -> 0x00RRGGBB
    pushad
    lea  esi,[ecx+ecx*2-1]
    lea  edi,[esi+ecx-3]
    add  esi,[___Palette]
    add  edi,[___Palette]
    std
@@:
    xor  eax,eax
    lodsb
    shl  eax,8
    lodsb
    shl  eax,8
    lodsb
    stosd
    loop @b
    cld
    popad
    ret

;-------------------------------------------------------------------------------
;This routine substracts [___cur_info] from all pointers in the
;structure located at [___cur_info]
make_multi_image_structure_relocatable:
    mov  esi,[___cur_info]
    mov  eax,esi
    mov  ecx,[___img_count]
.next_image:
    xor  ebx,ebx
    or	 ebx,[esi+20] ;pointer to image, 'mov' doesn't affect flags
    js	 @f	      ;see Note #3, subnote #2 of the IPC interface docs
    sub  [esi+20],eax
@@:
    or	 dword[esi],0 ;last image's pointer 'Next_image' is 0
    jz	 .ended       ;check it
    push dword[esi]
    sub  [esi],eax
    pop  esi
    loop .next_image
.ended:
    ret
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
;TGA decoder constants
;-------------------------------------------------------------------------------
top_down_row_order equ 32 ;bit5
interlace_type	   equ 192;bits6/7
;-------------------------------------------------------------------------------
